/*
 *  main.c
 *  Project Word-Uhr V1.5a
 *  Created by W.Brust on 19.05.13
 *  Copyright 2013 W.Brust All rights reserved.
 *  LCD Modul 4 Zeilen 20 Zeichen je Zeile
 *  Änderungen:
 *  28.12.13 Sommer/Winterzeit 
 *  05.11.15 Wort ausgabe
 *  24.11.15 Graphic LCD Modul BATRON BT-120032
 *  08.12,15 Strings in ProgMem ausgelagert
 *  18.12.15 Plausibilitätsprüfung und berechnung des Wochentag 
 *  20.12.15 Kalenderwoche anzeigen
 *	04.01.16 bei Minuten < 21 kein Wortumbruch 12h Anzeige
 *			 Menü zum einstellen verbessert
 *
 *  Baustellen!: erstmal keine
 *
 
		   Display dezi aus		 Display dezi ein
		.--------------------. .--------------------.
		| Es ist Nachmittag  | | Es ist    21:33:37 |
		| siebzehn Uhr       | | einunzwanzig Uhr   |
		| achtundfünfzig     | | dreiunddreißig     |
		| Di 24.11.2015 Wo48 | | Sa 24.10.2015 Wo43 |
		'--------------------' '--------------------'
*/
#include "main.h"

volatile uint8_t s=0; 
volatile uint8_t Sekunden=0;
uint8_t Minuten=0;
uint8_t Stunden=0;
uint8_t Monat=1;
uint8_t Tag=1;
uint8_t Wtag=2;			//Wochentag, 0..6, 0 = Sonntag
uint8_t _woche=1;		//Kalenderwoche
uint8_t Jahr=13;
uint8_t MESZ=1;			//Sommerzeit/Winterzeit Umstellung Ein, 0 = Aus UTC
uint8_t sz=0;			//MEZ, 1 = MESZ
uint8_t set=0;			//Menue auswahl Stellen
uint8_t Word=0;			//"viertel nach/viertel vor", 1 = "viertel/dreiviertel"
uint8_t _24=0;			//Wort Anzeige 24h, 1 = 12h
uint8_t dezi=1;			//dezimale Anzeige Ein [00:00:00], 0 = Tageszeit		
uint8_t sw_wo=1;		//switch Woche
uint8_t refresh=1;		//switch Display
uint8_t key_press=0;	//key press detect (Tasten code)
//uint8_t debug;


ISR(TIMER0_OVF_vect)	// keypress by Peter Dannegger
{
	static uint8_t ct0, ct1, key_state;
	uint8_t i;
	
	i = key_state ^ ~((PIN(Key_PORT)|0xF0));// key changed?
	ct0 = ~( ct0 & i );						// reset or count ct0
	ct1 = ct0 ^ (ct1 & i);					// reset or count ct1
	i &= ct0 & ct1;							// count until roll over?
	key_state ^= i;							// then toggle debounced state
	key_press |= key_state & i;				// 0->1: key press detect
}

ISR(TIMER2_COMP_vect) 
{
	s++;				// alle (F_CPU/256/125) 
	
	if (s==250)			// jede Sekunde (F_CPU/256/125/s),   s = 125 bei F_CPU 4,0MHz
		{				//									 s = 200 bei F_CPU 6,4MHz
			s=0;		//									 s = 250 bei F_CPU 8,0MHz
			Sekunden++;
		}
}


void Anzeigen (void)
{
	if ( (!s && (Sekunden <60)) || set) //jede Sekunde oder beim Stellen 
		{
			if (set)
				{
					_delay_ms(5); //beseitigt Flimmern des Displays (BT-120032)
					LCDPos(1,5);
					Display(Stunden);
					LCDWriteByte(':');
					Display(Minuten);
					LCDWriteByte(':');
					Display(Sekunden);
					LCDPos(2,5);
					Display(Tag);
					LCDWriteByte('.');
					Display(Monat);
					LCDWriteByte('.');
					Display(Jahr);
				}
			if (dezi && !set)
				{
					LCDPos(1,12);
					Display(Stunden);
					LCDWriteByte(':');
					Display(Minuten);
					LCDWriteByte(':');
					Display(Sekunden);
				}
		}
	
	Ausgabe();
}

void Ausgabe(void)
{
	if (refresh && !set)
		{	
			uint8_t temp =_24;
				
			LCDPos(1,1);
			P_LCDWrite(_Es_ist);
		 
				if (!dezi)
				  {
					P_LCDWrite(S_Blank); //Rest der Zeile löschen
					LCDPos(1,8);
					if ((Stunden >2 && Stunden<10))P_LCDWrite(Morgens);	 //03-09:59
					if ((Stunden>9 && Stunden<12))P_LCDWrite(V_mittag);	 //10-11:59
					if ((Stunden >11 && Stunden<14))P_LCDWrite(Mittag);  //12-13:59
					if ((Stunden >13 && Stunden<18))P_LCDWrite(N_mittag);//14-17:59
					if ((Stunden >17 && Stunden<22))P_LCDWrite(Abends);	 //18-21:59
					if ((Stunden >21)||(Stunden <3))P_LCDWrite(Nachts);	 //22-02:59
				  }
					
			LCDPos(2,1);
			P_LCDWrite(Blank);	//Zeilen löschen
			LCDPos(3,1);
			P_LCDWrite(Blank);
			LCDPos(4,1);
			P_LCDWrite(Blank);
			LCDPos(2,2);
					
				switch (Minuten)
				  {
					case  5:P_LCDWrite(_5_nach);_24=1;_Stunden(2);break;
					case 10:P_LCDWrite(_10_nach);_24=1;_Stunden(2);break;
					case 15:viertel_nach();break;
					case 20:P_LCDWrite(_20_nach);_24=1;_Stunden(2);break;
					case 25:vor_halb();break;
					case 30:P_LCDWrite(_halb);_24=1;_Stunden(1);break;
					case 35:nach_halb();break;
					case 40:P_LCDWrite(_20_vor);_24=1;_Stunden(1);break;
					case 45:viertel_vor();break;
					case 50:P_LCDWrite(_10_vor);_24=1;_Stunden(1);break;
					case 55:P_LCDWrite(_5_vor);_24=1;_Stunden(1);break;
					default:_Stunden(0);P_LCDWrite(_Uhr);_Minuten();break;
				  }
			
			LCDPos(4,1); 
			Display_Wtag();
			Display(Tag);
			LCDWriteByte('.');
			Display(Monat);
			LCDWriteByte('.');
			P_LCDWrite(_jh);
			Display(Jahr);
			LCDPos(4,16);
			P_LCDWrite(_wo);
			Display(_woche);
			_24 = temp;
			refresh=0;
		}
}

void vor_halb (void)
{
	P_LCDWrite(_5_vor_halb);
	switch (Stunden)			//Wortumbruch 
		{
			case  6:cr;break;//#def
			case 18:cr;break;
		}
	_24=1;
	_Stunden(1);
}

void nach_halb (void) 
{
	P_LCDWrite(_5_nach_halb);
	switch (Stunden)			//Wortumbruch 
		{
			case  5:cr;break;//#def 
			case  6:cr;break;
			case 11:cr;break;
			case 17:cr;break;
			case 18:cr;break;
			case 23:cr;break;
		}
	_24=1;
	_Stunden(1);
}

void viertel_vor (void)
{
	if (Word)
		{
			P_LCDWrite(_3_viertel);
		}
	else 
		{
			P_LCDWrite(_viertel_vor);
		}
	_24=1;
	_Stunden(1);
}

void viertel_nach (void)
{	
	_24 = 1;
	
	if (Word)
		{
			P_LCDWrite(_viertel);_Stunden(1);
		}
	else 
		{
			P_LCDWrite(_viertel_nach);_Stunden(2);
		}
}

void _Stunden (uint8_t Data)
{ 
	uint8_t Stunde = Stunden;
	
		if (_24 && Stunde>12)Stunde-=12;//12h Wort
	
		if (Data == 1)
			{
				Stunde++;
				if (!Stunden) Stunde=24;//eins
				if (Stunde == 1)  Stunde=24;
				if (Stunde == 13) Stunde=24;
			}
	
		if ((Data == 2) && (Stunde == 1)) Stunde=24;
		if ((Data == 2) && !Stunden) Stunde=12;//null Uhr
	
	P_LCDWrite ( ( (char*)pgm_read_word(&(hh[Stunde]))));//Stunde ==> Disply

}					

					
void _Minuten (void)
{
	uint8_t Minute = Minuten;
	
	if(_24 && Minute<21)
	   {
		   ;// Skip
	   }
	  else
	   {
		if((Minute>20) || ((Stunden>12) && (Minute>12)) || (Stunden>20))LCDPos(3,1);//Wortumbruch
	   }
	if((Minute %5))P_LCDWrite ( ( (char*)pgm_read_word(&(mm[Minute]))));//Minute ==> Disply
}
	
						
void Display_Wtag (void)
{
	switch (Wtag) 
	{
		case 1:P_LCDWrite(_Mo);break;//Montag
		case 2:P_LCDWrite(_Di);break;//Dienstag 
		case 3:P_LCDWrite(_Mi);break;//Mittwoch
		case 4:P_LCDWrite(_Do);break;//Donnerstag
		case 5:P_LCDWrite(_Fr);break;//Freitag
		case 6:P_LCDWrite(_Sa);break;//Samstag
		default:P_LCDWrite(_So);break;//Sonntag
	}
}

void Display (uint8_t Data)
{
	char __str[3];
	itoa(Data,__str,10);
	if(Data<10) LCDWriteByte('0');
	LCDWrite(__str);
}

void Kalenderwoche(void)
{
	if( Wtag==1 && sw_wo==1)// einmal Montags
	{
		_woche = Woche(Tag,Monat,Jahr);
		sw_wo=0;//switch
		
		if(!set)
			{
				LCDPos(4,18);
				Display(_woche);
			}
	}
}

//Plausibilitätsprüfung
void Plausi(void) 
{
	uint8_t temp=nTage_Monat(Monat,Jahr);
	if( Tag>temp)Tag=temp;// Korrektur
}

//Sommer/Winterzeit setzen
void set_WZ(void)
{
	if( Monat >= 4 || Monat <= 9 )sz=1;// Sommerzeit
	
	if( Monat < 3 || Monat > 10 )sz=0;// Winterzeit
		
	if( Tag - Wtag >= 25 && (Wtag || Stunden >= 3) )// nach den letzten Sontag 2:00
		{ 
			if( Monat == 10 )sz=0;
		}
	
			else										 
				{	
					if( Monat == 3 )sz=0;	// vor den letzten Sontag 2:00
				}
}

//Wochentag berechnung
short Wo_tag(uint8_t MT, uint8_t MM, uint8_t MJ) 
{
	char MJH, MMarr; unsigned int uJahr;
	char arrMonatsOffset[13] = { 0, 0, 3, 3, 6, 1, 4, 6, 2, 5, 0, 3, 5};
	
	uJahr=MJ+2000;
	MT = (MT % 7);						
	MMarr = arrMonatsOffset[MM];
	MJ = ((uJahr %100) + ((uJahr %100) / 4)) %7;
	MJH = (3 - ((uJahr / 100) %4))*2;
	
	
	if ((MM <= 2) && !(uJahr %4))	//es ist ein Schaltjahr
	{
		MT+=6;						
	}
	
	return (MT + MMarr + MJ + MJH) %7;
}

//Anzahl Tage pro Monat
short nTage_Monat(uint8_t MM, uint8_t MJ)
{
	char arrTage_Monat[13] = {  0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
	unsigned int uJahr=2000+MJ;
	
	if (MM == 2)// Februar: Schaltjahr
		{
		if (!(uJahr %4))
			return 29;
		else
			return 28;
		}
	
	return arrTage_Monat[MM];
}                   

//Der wievielte Tag im Jahr?
short Jahres_Tag(uint8_t MT, uint8_t MM, uint8_t MJ)
{
	uint16_t LokalTag = MT;
	uint8_t LokalMonat = MM;
	
	while (LokalMonat > 1)
		{
			LokalMonat--;
			LokalTag += nTage_Monat(LokalMonat, MJ);
		}
	
	return LokalTag;
}

//Kalenderwoche berechnen
short Woche(uint8_t MT,uint8_t MM,uint8_t MJ)
{
	short nTag = Jahres_Tag(MT, MM, MJ);
	short n1Jan = Wo_tag(1, 1, MJ);	// Wochentag des 1. Januar
	if (n1Jan >= 5) n1Jan -= 7;	// Freitag und Samstag
	if ( (nTag + n1Jan) <= 1)
		{
			return Woche(31, 12, MJ - 1);
		}
	short nWoche = ((nTag + n1Jan + 5) / 7);
	short uJahr=2000+MJ;
	
	assert(nWoche >= 1);
	assert(nWoche <= 53);
	
	if (nWoche == 53)
		{
		
		if (    (n1Jan  ==  4) // Donnerstag
			||  (n1Jan  == -3) // Donnerstag
			||  ((n1Jan ==  3) && !(uJahr %4))//Schaltjahr
			||  ((n1Jan == -4) && !(uJahr %4))
			)
				{
					; // Skip
				}
		else
				nWoche = 1; // Korrektur
		}
	return nWoche;
}	

//Uhr
 void Uhr (void)
{
	if (Sekunden == 60)
	 { 
		Sekunden = 0;	
		Minuten++;
		refresh=1;		//Display
	 }
	
	if (Minuten == 60)
	 { 
		Minuten = 0;	
		Stunden++;
	 }
	
	if (Stunden == 24)
	 { 
		Stunden = 0;			
		Tag++;
		Wtag++;
		
		if (Wtag==7)
		 {
			Wtag=0;
			sw_wo=1;		//switch für Kalenderwoche setzen
		 }
		
		if (Tag==32)			
		 {
			Monat++;
			Tag=1;
		 } 
		
		else if    (Tag==31)	
			{
				if ((Monat==4) || (Monat==6) || (Monat==9) || (Monat==11))
					{
						Monat++;
						Tag=1;
					}
			} 
		
		else if    (Tag==30)	 
			{
				if(Monat==2)		
					{
						Monat++;			 
						Tag=1;
					}
			} 
		
		else if    (Tag==29)	
			
			{
				if((Monat==2) && (Jahr %4)) /* es ist kein Schaltjahr *)
												
					*) 
					 
					Die Regel lautet: Alles, was durch 4 teilbar ist, ist ein Schaltjahr.
					Es sei denn, das Jahr ist durch 100 teilbar, dann ist es keins.
					Aber wenn es durch 400 teilbar ist,	ist es doch wieder eins.				     
										      
					falls es mit der einfachen Berechnung nach 2099 Probleme geben sollte,
					nehme ich ab 2100 gerne Beschwerden entgegen.
					 
					*/
					
				{	
					
					Monat++;		
					Tag=1;
				}
			} 
		
		if (Monat==13)			// neues Jahr
		 {
			Jahr++;
			Monat=1;
			if (Jahr>99) 
			 {
				Jahr=0;
			 }
		 }
	 }
	_MESZ();
	Anzeigen ();
	Kalenderwoche();
	Tasten();
}

//Einstellen der Uhr
void Tasten (void)
{
	if (key_press) 
	{
		refresh=0;
		switch (key_press) 
		{
			case Taste_Plus: //Tasten code4
				{
					switch (set)
						{
							case  1:TCNT2=0;s=0;Sekunden=0;break;
							case  2:Stunden++;if(Stunden>23)Stunden=0;set_WZ();break;	
							case  3:Minuten++;if(Minuten>59)Minuten=0;break;
							case  4:Tag++;	  if(Tag>31)Tag=1;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break;			
							case  5:Monat++;  if(Monat>12)Monat=1;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break;
							case  6:Jahr++;	  if(Jahr>99)Jahr=0;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break; 
							case  7:MESZ=1;LCDPos(1,18);P_LCDWrite(_Ein);break;	
							case  8:Word=1;LCDPos(1,14);P_LCDWrite(_W_Sued);break;
							case  9:_24=1;LCDPos(1,14);P_LCDWrite(_W_h_12);break;
							case 10:dezi=1;LCDPos(1,18);P_LCDWrite(_Ein);break;
						}							
				}break;
								
			case Taste_Minus: //Tasten code2
				{
					switch (set)
						{
							case  1:TCNT2=0;s=0;Sekunden=0;break;
							case  2:Stunden--;if(Stunden>23)Stunden=23;set_WZ();break;
							case  3:Minuten--;if(Minuten>59)Minuten=59;break;
							case  4:Tag--;	  if(Tag==0)Tag=31;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break;
							case  5:Monat--;  if(Monat==0)Monat=12;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break;
							case  6:Jahr--;	  if(Jahr>99)Jahr=99;
									Wtag = Wo_tag(Tag,Monat,Jahr);set_WZ();break;
							case  7:MESZ=0;LCDPos(1,18);P_LCDWrite(_Aus);break;
							case  8:Word=0;LCDPos(1,14);P_LCDWrite(_W_Nord);break;
							case  9:_24=0;LCDPos(1,14);P_LCDWrite(_W_h_24);break;
							case 10:dezi=0;LCDPos(1,18);P_LCDWrite(_Aus);break;
						}
				}break;		
				
			case Taste_Set:	//Tasten code1
				{
					set++;
					if(set==1)LCDCls();
					LCDPos(1,14);
					switch (set)
						{
							case  1:P_LCDWrite(_Sek);break;
							case  2:P_LCDWrite(_Std);break;
							case  3:P_LCDWrite(_Min);break;
							case  4:P_LCDWrite(Blank_6);LCDPos(2,14);P_LCDWrite(_Tag);break;
							case  5:P_LCDWrite(Blank_6);LCDPos(2,14);P_LCDWrite(_Mon);break;
							case  6:P_LCDWrite(Blank_6);LCDPos(2,14);P_LCDWrite(_Jahr);break;
							       								
							case  7:LCDPos(1,14);P_LCDWrite(_S_W);LCDPos(1,18);
								
									if(MESZ)
										{
											P_LCDWrite(_Ein);
										}
									else 
										{
											P_LCDWrite(_Aus);
											
										}
								
									Plausi();Wtag = Wo_tag(Tag,Monat,Jahr);
									_woche = Woche(Tag,Monat,Jahr);set_WZ();
									sw_wo=0;LCDPos(2,1);Display_Wtag();LCDPos(2,15);
									P_LCDWrite(Blank_6);LCDPos(2,14);P_LCDWrite(_wo);
									Display(_woche);LCDPos(1,14);break;
								
							case  8:if (Word)P_LCDWrite(_W_Sued);else P_LCDWrite(_W_Nord);break;
							case  9:if (_24)P_LCDWrite(_W_h_12);else P_LCDWrite(_W_h_24);break;
							case 10:P_LCDWrite(_Dez);LCDPos(1,18);
								
									if(dezi)
										
										{
											P_LCDWrite(_Ein);
										}
									else 
										{
											P_LCDWrite(_Aus);
										}
									break;
								
							case 11:set=0;sw_wo=1;refresh=1;LCDCls();break;	
						}
				}break;	
		}
		key_press=0;
	} 
}


//Sommerzeit / Winterzeit Umstellung
void _MESZ(void)
{
	if (MESZ)
	{
		if (!(sz))	// es ist Winterzeit
			{
				if ((Stunden == 2 && Monat == 3))	
					{
						if ((Tag-Wtag) >= 25)
							{
								Stunden++;			//auf Sommerzeit umstellen
								sz=1;				//Sommerzeit MESZ
							}
					}
			}

		else 
			{
				if ((Stunden == 3 && Monat == 10))	
					{
						if ((Tag-Wtag) >= 25)
							{
								Stunden--;			//auf Winterzeit umstellen
								sz=0;				//Winterzeit MEZ
							}
					}
			}
	}
}

/*
 ***************************************************
 Hauptprogramm
 ***************************************************
*/

int main()
{
		
#ifdef BT_120032							// nur MCU ATmega32
	DDR(LCD_PORT) = 0xFF;					// Port output
	DDR(LCD_RESET)= 0xFF;
	DDR(Key_PORT)|=(1<<LCD_E)|(1<<LCD_RS);	// Pins output
	Key_PORT = 0x3F;						// Key_Port Pins pullup
	LCD_PORT = 0x00;
	LCD_RESET=0x80;							// Reset Pin HI, unused Pins LO
	PORTB=0xFF;								// unused Pins pullup
	TCCR2 |= (1<<WGM21)|(1<<CS22)|(1<<CS21);// CTC Mode Timer2, Prescaler Timer2 = 256
#else
	DDR(LCD_PORT) = 0xFF;					// Port output
	Key_PORT = 0xFF;						// Key_Port Pins pullup
	LCD_PORT = 0x00;
	//PORTA=0xFF;								// unused Pins pullup [ nicht bei MCU ATmega8 ]	
	PORTB=0xFF;								// unused Pins pullup	
	TCCR2 |= (1<<WGM21)|(1<<CS22)|(1<<CS21);// CTC Mode Timer2, Prescaler Timer2 = 256
										
#endif
	
	OCR2  |= 124;							// Compare register Timer2 = 124 (for Loop 0-124 => 125)
	TCCR0 = (1<<CS02);						// timer0 prescaler = 256
	TIMSK = (1<<TOIE0)|(1<<OCIE2);			// enable timer0 OVF interrupt, Timer2 comp match interrupt 
	LCDInit();
	LCDCls();
	sei();									// enable global interrupt 
	
	P_LCDWrite(rahmen_1);
	LCDPos(2,1);P_LCDWrite(rahmen_2);
	LCDPos(3,1);P_LCDWrite(rahmen_2);
	LCDPos(4,1);P_LCDWrite(rahmen_3);

	while (!(key_press))
		{
			LCDPos(2,5);P_LCDWrite(txt_1);
			LCDPos(3,5);P_LCDWrite(txt_2);
			_delay_ms(1500);
			LCDPos(2,2);P_LCDWrite(T_Blank);
			LCDPos(3,2);P_LCDWrite(T_Blank);
			_delay_ms(1000);
		}
	
	TCNT2=0;s=0;Sekunden=0;
	LCDCls();
	key_press=1;
	
for (;;)//mainloop
	{
		Uhr();
	}
}
			

