/*
 *  main.h
 *  Project Word-Uhr
 *
 *  Created by W.Brust on 19.05.13
 *  Copyright 2014 2013 W.Brust All rights reserved.
 */


#include <stdlib.h>
#include <assert.h>
#include <avr/io.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "Strings.h"


/*-----------------------------------------------------*/
//Display auswahl, Achtung! auch im Makefile einstellen

//#define BT_120032		//Display BT-120032 

/*-----------------------------------------------------*/

#ifdef BT_120032		//Display BT-120032
#include "BT-120032.h"
#else					
#include "lcd.h"		//Display HD44780-Kompatibel
#endif

/*
#ifndef F_CPU
#define F_CPU 8000000UL
#endif
*/

#define Key_PORT PORTD
#define Taste_Set		1	//Key_PORT PIN 0 
#define Taste_Minus		2	//Key_PORT PIN 1 
#define Taste_Plus		4	//Key_PORT PIN 2 
#define DDR(x) (*(&x - 1))	// Adresse des data direction register port x
#define PIN(x) (*(&x - 2))  // Address des input register port x

#define cr LCDPos(3,2)

void Display_Wtag (void);
void Display (uint8_t);
void Anzeigen (void);
void Ausgabe(void);
void Uhr (void);
void Tasten (void);
void _MESZ(void);
void _Stunden (uint8_t);
void _Minuten (void);
void Plausi(void);
void viertel_vor (void);
void viertel_nach (void);
void vor_halb (void);
void nach_halb (void);
void Kalenderwoche(void);
short Wo_tag(uint8_t,uint8_t,uint8_t);
short nTage_Monat(uint8_t,uint8_t);
short Jahres_Tag(uint8_t,uint8_t,uint8_t);
short Woche(uint8_t,uint8_t,uint8_t);